Index: tags/Ver2.2.0RC1/xpressme_integration_kit/blocks/block_common.php
===================================================================
--- trunk/xpressme_integration_kit/blocks/block_common.php	(revision 434)
+++ tags/Ver2.2.0RC1/xpressme_integration_kit/blocks/block_common.php	(revision 450)
@@ -18,6 +18,6 @@
 endif;
 
-if(!function_exists("dropdown_cats_options")):
-function dropdown_cats_options($sort_column = 'ID', $sort_order = 'asc', $selected=array()) 
+if(!function_exists("categorie_select")):
+function categorie_select($option_name = '',$value='',$row_num=0 ,$sort_column = 'ID', $sort_order = 'asc')
 {
     $mydirpath = dirname(dirname(__FILE__));
@@ -30,6 +30,8 @@
 	$xoopsDB =& Database::getInstance();
 	$myts =& MyTextSanitizer::getInstance();
-    $selected = is_array($selected)?$selected:array($selected);
+    $selected = explode(',' , $value);
+	$isAll = (count($selected)==0||empty($selected[0]))?true:false;
     $sort_column = 'cat_'.$sort_column;
+    if (empty($row_num)) $size = ''; else $size = 'size="' . $row_num . '"';
 	include $mydirpath.'/wp-includes/version.php';
 	if ($wp_db_version < 6124) {
@@ -53,21 +55,95 @@
     }
 	$res =  $xoopsDB->query($query, 0, 0);
+	$option = "\t<option value=\"0\" ";
+	if ($isAll) $option .= " selected=\"selected\"";
+	$option .= ">"._MB_XP2_ALL ."</option>\n";
+
     if ($res !== false){
  		while($row = $xoopsDB->fetchArray($res)){
             $cat_name = $row['cat_name'];
             $cat_ID = $row['cat_ID'];
-            echo "\t<option value=\"".$cat_ID."\"";
+            $option .= "\t<option value=\"".$cat_ID."\"";
             if (in_array($cat_ID, $selected))
-                echo ' selected="selected"';
-            echo '>';
-            echo $myts->htmlspecialchars($cat_name);
-            echo "</option>\n";
+                $option .= ' selected="selected"';
+            $option .= '>';
+            $option .= $myts->htmlspecialchars($cat_name);
+            $option .= "</option>\n";
         }
     }
-    return;
+    $output = _MB_XP2_CATS_SELECT ."<br />\n";
+    $output .= 	"<input type='hidden' name='$option_name' value='$value' />\n";
+    $output .= '&nbsp;&nbsp;<select name="categorie" '.$size.' multiple="multiple" onclick="CatSelect()">' ."\n";
+    $output .= $option;
+    $output .= '</select><br />';
+    $output .= '
+<script type="text/javascript">
+    function CatSelect(){
+        var idx=new Array();
+        var sel=document.forms["blockform"].elements["categorie"].options;
+        for(var i=0, n=0; i<sel.length; i++){
+            if(sel[i].selected){ idx[n++]=sel[i].value; }
+        }
+        if(idx.length>0){
+        	document.forms["blockform"].elements["' .$option_name . '"].value = idx;
+		}
+    }
+</script>
+';
+    
+    return $output;
+
+}
+endif;
+
+if(!function_exists("comment_type_select")):
+function comment_type_select($option_name = '',$value='')
+{
+    $selected = explode(',' , $value);
+	$isAll = (count($selected)==0||empty($selected[0]))?true:false;
+
+    $option = "<option value=\"0\" ";
+    if ($isAll) $form .= " selected=\"selected\"";
+    $option .= ">"._MB_XP2_ALL ."</option>";
+
+    $option .= "<option value=\"1\" ";
+    if (in_array(1, $selected))
+		$option .= " selected=\"selected\"";
+    $option .= ">"._MB_XP2_COMMENT ."</option>";
+
+    $option .= "<option value=\"2\" ";
+    if (in_array(2, $selected))
+		$option .= " selected=\"selected\"";
+    $option .= ">"._MB_XP2_TRUCKBACK ."</option>";
+
+    $option .= "<option value=\"3\" ";
+    if (in_array(3, $selected))
+		$option .= " selected=\"selected\"";
+    $option .= ">"._MB_XP2_PINGBACK ."</option>";
+
+    $output = _MB_XP2_COM_TYPE . "<br />\n";
+    $output .= 	"<input type='hidden' name='$option_name' value='$value' />\n";
+    $output .= '&nbsp;&nbsp;<select name="com_type" multiple="multiple" onclick="ComTypeSelect()">' ."\n";
+    $output .= $option;
+    $output .= '</select><br />';
+    $output .= '
+<script type="text/javascript">
+    function ComTypeSelect(){
+        var idx=new Array();
+        var sel=document.forms["blockform"].elements["com_type"].options;
+        for(var i=0, n=0; i<sel.length; i++){
+            if(sel[i].selected){ idx[n++]=sel[i].value; }
+        }
+        if(idx.length>0){
+        	document.forms["blockform"].elements["' .$option_name . '"].value = idx;
+		}
+    }
+</script>
+';
+    
+    return $output;
+
 }
 endif;
 
 
-
 ?>
Index: tags/Ver2.2.0RC1/xpressme_integration_kit/blocks/popular_posts_block.php
===================================================================
--- trunk/xpressme_integration_kit/blocks/popular_posts_block.php	(revision 434)
+++ tags/Ver2.2.0RC1/xpressme_integration_kit/blocks/popular_posts_block.php	(revision 450)
@@ -23,5 +23,5 @@
 		$time_format = empty( $options[5] ) ? '' : $options[5] ;
 		$tag_select = $options[6] ;
-		$selected = array_slice($options, 7); // get allowed cats
+		$cat_select = empty( $options[7] ) ? '0' : $options[7] ;
 
 		$mydirpath = XOOPS_ROOT_PATH . '/modules/' . $mydirname;
@@ -44,17 +44,5 @@
 		}
 
-	    $form .= _MB_XP2_CATS_SELECT ."<br />\n";
-	    $isAll = (count($selected)==0||empty($selected[0]))?true:false;
-	    $form .= "&nbsp;&nbsp;<select name=\"options[]\" multiple=\"multiple\">";
-	    $form .= "<option value=\"0\" ";
-	    if ($isAll) $form .= " selected=\"selected\"";
-	    $form .= ">"._MB_XP2_ALL ."</option>";
-		ob_start();
-		dropdown_cats_options('ID','asc',$selected);
-		$list_str = ob_get_contents();
-		ob_end_clean();
-	    $form .= $list_str. "</select><br />";
-//	    $form .="<br /><input type='text' size='60' name='options[5]' value='".htmlspecialchars($this_template,ENT_QUOTES)."' />";
-
+		$form .= categorie_select('options[7]' , $cat_select);
 		return $form;
 	}
Index: tags/Ver2.2.0RC1/xpressme_integration_kit/blocks/recent_comments_block.php
===================================================================
--- trunk/xpressme_integration_kit/blocks/recent_comments_block.php	(revision 434)
+++ tags/Ver2.2.0RC1/xpressme_integration_kit/blocks/recent_comments_block.php	(revision 450)
@@ -23,5 +23,5 @@
 		$date_format = empty( $options[4] ) ? '' : $options[4] ;
 		$time_format = empty( $options[5] ) ? '' : $options[5] ;
-	    $selected = array_slice($options,6); // get allowed cats
+		$com_select = empty( $options[6] ) ? '0' : $options[6] ;
 
 		$mydirpath = XOOPS_ROOT_PATH . '/modules/' . $mydirname;
@@ -37,27 +37,5 @@
 		$form .= _MB_XP2_TIME_FORMAT .": <input type='text' name='options[5]' value='" . $time_format . "' /><br />\n";
 	    $form .= "<br />\n";
-	    $form .= _MB_XP2_COM_TYPE . "<br />\n";
-	    $isAll = (count($selected)==0||empty($selected[0]))?true:false;
-	    $form .= "&nbsp;&nbsp;<select name=\"options[]\" multiple=\"multiple\">";
-		    $form .= "<option value=\"0\" ";
-		    if ($isAll) $form .= " selected=\"selected\"";
-		    $form .= ">"._MB_XP2_ALL ."</option>";
-
-		    $form .= "<option value=\"1\" ";
-		    if (in_array(1, $selected))
-				$form .= " selected=\"selected\"";
-		    $form .= ">"._MB_XP2_COMMENT ."</option>";
-
-		    $form .= "<option value=\"2\" ";
-		    if (in_array(2, $selected))
-				$form .= " selected=\"selected\"";
-		    $form .= ">"._MB_XP2_TRUCKBACK ."</option>";
-
-		    $form .= "<option value=\"3\" ";
-		    if (in_array(3, $selected))
-				$form .= " selected=\"selected\"";
-		    $form .= ">"._MB_XP2_PINGBACK ."</option>";
-		$form .= "</select><br />";
-		//	    $form .="<br /><input type='text' size='60' name='options[5]' id='this_template' value='".htmlspecialchars($this_template,ENT_QUOTES)."' />";
+	    $form .= comment_type_select('options[6]' , $com_select);
 
 
Index: tags/Ver2.2.0RC1/xpressme_integration_kit/blocks/recent_posts_content_block.php
===================================================================
--- trunk/xpressme_integration_kit/blocks/recent_posts_content_block.php	(revision 434)
+++ tags/Ver2.2.0RC1/xpressme_integration_kit/blocks/recent_posts_content_block.php	(revision 450)
@@ -19,13 +19,13 @@
 		$mydirname = empty( $options[0] ) ? 'xpress' : $options[0] ;
 		$this_template = empty( $options[1] ) ? 'db:'.$mydirname.'_recent_posts_content_block.html' : trim( $options[1] );
-		$day_select = ($options[2])?intval($options[2]):0;
-		$day_size = ($options[3])?intval($options[3]):0;
-		$disp_count =  ($options[4])?intval($options[4]):10;
-		$excerpt = empty( $options[5] ) ? false : true ;
-		$excerpt_size =  ($options[6])?intval($options[6]):100;
-		$date_format = empty( $options[7] ) ? '' : $options[7] ;
-		$time_format = empty( $options[8] ) ? '' : $options[8] ;
-		$tag_select = $options[9] ;
-	    $selected = array_slice($options,10); // get allowed cats
+		$disp_count =  ($options[2])?intval($options[2]):10;
+		$excerpt = empty( $options[3] ) ? false : true ;
+		$excerpt_size =  ($options[4])?intval($options[4]):100;
+		$date_format = empty( $options[5] ) ? '' : $options[5] ;
+		$time_format = empty( $options[6] ) ? '' : $options[6] ;
+		$tag_select = $options[7] ;
+		$cat_select = empty( $options[8] ) ? '0' : $options[8] ;
+		$day_select = ($options[9])?intval($options[9]):0;
+		$day_size = ($options[10])?intval($options[10]):0;
 
 		$mydirpath = XOOPS_ROOT_PATH . '/modules/' . $mydirname;
@@ -35,6 +35,22 @@
 		$form  = "MyDirectory <input type='text' name='options[0]' value='" . $mydirname . "' /><br />\n";
 	    $form .= "<input type='hidden' name='options[1]' id='this_template' value='".htmlspecialchars($this_template,ENT_QUOTES)."' /><br />";
-		$form .= "<br />";
-		$form .= _MB_XP2_DAY_SELECT . ':' . _MB_XP2_DAY_BETWEEN . '<select name="options[2]">';
+		$form .= _MB_XP2_COUNT .": <input type='text' name='options[2]' value='" . $disp_count . "' /><br />\n";
+		$form .= yes_no_radio_option('options[3]', _MB_XP2_P_EXCERPT , $excerpt) . "<br />\n";
+		$form .= _MB_XP2_P_EXCERPT_SIZE .": <input type='text' name='options[4]' value='" . $excerpt_size . "' /><br />\n";
+		$form .= _MB_XP2_DATE_FORMAT .": <input type='text' name='options[5]' value='" . $date_format . "' /><br />\n";
+		$form .= _MB_XP2_TIME_FORMAT .": <input type='text' name='options[6]' value='" . $time_format . "' /><br />\n";
+		
+		include $mydirpath .'/wp-includes/version.php' ;
+		if (wp_version_compare($wp_version, '>=','2.3')){
+			$form .= "<br />\n";
+			$form .= _MB_XP2_TAGS_SELECT .": <input type='text' name='options[7]' value='" . $tag_select . "' /><br />\n";
+		} else {
+			$form .= "<input type='hidden' name='options[7]' value='' /><br />\n";
+		}
+		
+	    $form .= categorie_select('options[8]' , $cat_select);
+	    
+	    $form .= "<br />";
+		$form .= _MB_XP2_DAY_SELECT . ':' . _MB_XP2_DAY_BETWEEN . '<select name="options[9]">';
 		switch ($day_select){
 		case 1:
@@ -55,33 +71,5 @@
 		$form .= '</select>';
 		
-		$form .= ' ' . _MB_XP2_DAYS_AND . " <input type='text' size='2' name='options[3]' value='" . $day_size . "' />" . _MB_XP2_DAYS_AGO . "<br />\n";
-
-		$form .= _MB_XP2_COUNT .": <input type='text' name='options[4]' value='" . $disp_count . "' /><br />\n";
-		$form .= yes_no_radio_option('options[5]', _MB_XP2_P_EXCERPT , $excerpt) . "<br />\n";
-		$form .= _MB_XP2_P_EXCERPT_SIZE .": <input type='text' name='options[6]' value='" . $excerpt_size . "' /><br />\n";
-		$form .= _MB_XP2_DATE_FORMAT .": <input type='text' name='options[7]' value='" . $date_format . "' /><br />\n";
-		$form .= _MB_XP2_TIME_FORMAT .": <input type='text' name='options[8]' value='" . $time_format . "' /><br />\n";
-		
-		include $mydirpath .'/wp-includes/version.php' ;
-		if (wp_version_compare($wp_version, '>=','2.3')){
-			$form .= "<br />\n";
-			$form .= _MB_XP2_TAGS_SELECT .": <input type='text' name='options[9]' value='" . $tag_select . "' /><br />\n";
-		} else {
-			$form .= "<input type='hidden' name='options[9]' value='' /><br />\n";
-		}
-		
-	    $form .= _MB_XP2_CATS_SELECT ."<br />\n";
-	    $isAll = (count($selected)==0||empty($selected[0]))?true:false;
-	    $form .= "&nbsp;&nbsp;<select name=\"options[]\" multiple=\"multiple\">\n";
-	    $form .= "\t<option value=\"0\" ";
-	    if ($isAll) $form .= " selected=\"selected\"";
-	    $form .= ">"._MB_XP2_ALL ."</option>\n";
-		ob_start();
-		dropdown_cats_options('ID','asc',$selected);
-		$list_str = ob_get_contents();
-		ob_end_clean();
-	    $form .= $list_str. "</select><br />\n";
-	    
-//	    $form .="<br /><input type='text' size='60' name='options[11]' id='this_template' value='".htmlspecialchars($this_template,ENT_QUOTES)."' />";
+		$form .= ' ' . _MB_XP2_DAYS_AND . " <input type='text' size='2' name='options[10]' value='" . $day_size . "' />" . _MB_XP2_DAYS_AGO . "<br />\n";
 
 		return $form;
Index: tags/Ver2.2.0RC1/xpressme_integration_kit/blocks/recent_posts_list_block.php
===================================================================
--- trunk/xpressme_integration_kit/blocks/recent_posts_list_block.php	(revision 434)
+++ tags/Ver2.2.0RC1/xpressme_integration_kit/blocks/recent_posts_list_block.php	(revision 450)
@@ -24,5 +24,5 @@
 		$time_format = empty( $options[6] ) ? '' : $options[6] ;
 		$tag_select = $options[7] ;
-		$selected = array_slice($options,8); // get allowed cats
+		$cat_select = empty( $options[8] ) ? '0' : $options[8] ;
 
 		$mydirpath = XOOPS_ROOT_PATH . '/modules/' . $mydirname;
@@ -47,17 +47,5 @@
 		}
 
-	    $form .= _MB_XP2_CATS_SELECT ."<br />\n";
-	    $isAll = (count($selected)==0||empty($selected[0]))?true:false;
-	    $form .= "&nbsp;&nbsp;<select name=\"options[]\" multiple=\"multiple\">\n";
-	    $form .= "\t<option value=\"0\" ";
-	    if ($isAll) $form .= " selected=\"selected\"";
-	    $form .= ">"._MB_XP2_ALL ."</option>\n";
-		ob_start();
-		dropdown_cats_options('ID','asc',$selected);
-		$list_str = ob_get_contents();
-		ob_end_clean();
-	    $form .= $list_str. "</select><br />\n";
-	    
-//	    $form .="<br /><input type='text' size='60' name='options[5]' value='".htmlspecialchars($this_template,ENT_QUOTES)."' />";
+	    $form .= categorie_select('options[8]' , $cat_select);
 
 		return $form;
Index: tags/Ver2.2.0RC1/xpressme_integration_kit/blocks/widget_block.php
===================================================================
--- trunk/xpressme_integration_kit/blocks/widget_block.php	(revision 434)
+++ tags/Ver2.2.0RC1/xpressme_integration_kit/blocks/widget_block.php	(revision 450)
@@ -20,5 +20,7 @@
 		$this_template = empty( $options[1] ) ? 'db:'.$mydirname.'_widget_block.html' : trim( $options[1] );
 		$title_show = empty( $options[2] ) ? false : true ;
-    	$selected = array_slice($options,3); // get allowed cats
+		$widget_select = empty( $options[3] ) ? '' : $options[3] ;
+
+		$selected = explode(',' , $widget_select);
 
 		if ($mydirname == 'wordpress'){
@@ -48,5 +50,7 @@
 		$form .= "<br />";
 		$form .= _MB_XP2_SELECT_WIDGET .":<br />\n";
-		$select = "&nbsp;&nbsp;&nbsp;<select name='options[]' multiple=\"multiple\">\n";
+    	$form .= "<input type='hidden' name='options[3]' value='$widget_select' />\n";
+
+		$select = "&nbsp;&nbsp;&nbsp;<select name='widget_sel' multiple=\"multiple\" onclick=\"WidgetSelect()\">\n";
 		$found = false;
 		foreach ( (array) $sidebars_widgets as $index => $sidebar ){
@@ -67,4 +71,19 @@
 
 		$select .=  "</select><br/>\n";
+    $select .= '
+<script type="text/javascript">
+    function WidgetSelect(){
+        var idx=new Array();
+        var sel=document.forms["blockform"].elements["widget_sel"].options;
+        for(var i=0, n=0; i<sel.length; i++){
+            if(sel[i].selected){ idx[n++]=sel[i].value; }
+        }
+        if(idx.length>0){
+        	document.forms["blockform"].elements["options[3]"].value = idx;
+		}
+    }
+</script>
+';
+		
 		if ($found){
 			$form = $form . $select;
Index: tags/Ver2.2.0RC1/xpressme_integration_kit/class/check_blocks_class.php
===================================================================
--- trunk/xpressme_integration_kit/class/check_blocks_class.php	(revision 434)
+++ tags/Ver2.2.0RC1/xpressme_integration_kit/class/check_blocks_class.php	(revision 450)
@@ -218,5 +218,5 @@
 		$option_arr_2 = explode( '|', $block_obj->getVar('options', 'n') );
 		
-		$excludes_block = array('widget_block.php','popular_posts_block.php','recent_comments_block.php','recent_posts_content_block.php','recent_posts_list_block.php');
+		$excludes_block = array();
 		
 		if (in_array($info['file'],$excludes_block)){
Index: tags/Ver2.2.0RC1/xpressme_integration_kit/include/xpress_block_render.php
===================================================================
--- trunk/xpressme_integration_kit/include/xpress_block_render.php	(revision 434)
+++ tags/Ver2.2.0RC1/xpressme_integration_kit/include/xpress_block_render.php	(revision 450)
@@ -137,15 +137,4 @@
 	}
 	
-	function get_block_file_path($mydirname,$file_name)
-	{
-		global $xoops_config;
-		$mydirpath = $xoops_config->xoops_root_path . '/modules/' . $mydirname;
-		$select_theme = get_xpress_theme_name($mydirname);
-		$block_file = $mydirpath . '/wp-content/themes/' . $select_theme . '/blocks/' . $file_name;
-
-		if (!file_exists($block_file))
-			$block_file =  $xoops_config->xoops_root_path . '/modules/' .$mydirname . '/wp-content/themes/xpress_default/blocks/' . $file_name;
-		return $block_file;
-	}
 	
     function xpress_block_cache_found($mydirname,$block_name)
@@ -184,6 +173,8 @@
 		if (strstr($call_url,$this_url)){			
 			$block_theme_file = get_block_file_path($mydirname,$inc_theme_file_name);
-			require_once $block_theme_file;
+			require_once $block_theme_file['file_path'];
 			$block = $call_theme_function_name($options);		//The block name and the called function name should be assumed to be the same name. 
+			if (!empty($block_theme_file['error']))
+				$block['err_message'] = $block_theme_file['error'];
 		} else {
 			if (xpress_block_cache_found($mydirname,$cache_title. $blockID)){
@@ -227,8 +218,10 @@
 
 			$block_theme_file = get_block_file_path($mydirname,$inc_theme_file_name);
-			require_once $block_theme_file;
+			require_once $block_theme_file['file_path'];
 			$render = $call_theme_function_name($options);		//The block name and the called function name should be assumed to be the same name. 			
 			$render_array['block'] = $render;
 			$render_array['block']['options'] = $block->options;
+			if (!empty($block_theme_file['error']))
+				$render_array['block']['err_message'] = $block_theme_file['error'];
 			if (xpress_block_cache_found($mydirname,$cache_title. $blockID)){	
 				$render_serialize = xpress_XML_serialize($render_array);
@@ -295,5 +288,5 @@
 		}
 	}
-
+	
 }	
 ?>
Index: tags/Ver2.2.0RC1/xpressme_integration_kit/wp-content/plugins/xpressme/include/custom_functions.php
===================================================================
--- trunk/xpressme_integration_kit/wp-content/plugins/xpressme/include/custom_functions.php	(revision 434)
+++ tags/Ver2.2.0RC1/xpressme_integration_kit/wp-content/plugins/xpressme/include/custom_functions.php	(revision 450)
@@ -792,5 +792,5 @@
 
 	$week_begins = intval(get_option('start_of_week'));
-	$head_pattrn = '<thead>\s*<tr>\s*(<th[^>]*>.*<\/th>)\s*(<th[^>]*>.*<\/th>)\s*(<th[^>]*>.*<\/th>)\s*(<th[^>]*>.*<\/th>)\s*(<th[^>]*>.*<\/th>)\s*(<th[^>]*>.*<\/th>)\s*(<th[^>]*>.*<\/th>)\s*<\/tr>\s*<\/thead>';
+	$head_pattrn = '<thead>\s*<tr>\s*(<th[^>]*>[^<]*<\/th>)\s*(<th[^>]*>[^<]*<\/th>)\s*(<th[^>]*>[^<]*<\/th>)\s*(<th[^>]*>[^<]*<\/th>)\s*(<th[^>]*>[^<]*<\/th>)\s*(<th[^>]*>[^<]*<\/th>)\s*(<th[^>]*>[^<]*<\/th>)\s*<\/tr>\s*<\/thead>';
 	if(preg_match('/'. $head_pattrn . '/s' ,$calendar,$head_match)){
 		$sun_index = 1 - $week_begins;
Index: tags/Ver2.2.0RC1/xpressme_integration_kit/wp-content/plugins/xpressme/include/xpress_common_functions.php
===================================================================
--- trunk/xpressme_integration_kit/wp-content/plugins/xpressme/include/xpress_common_functions.php	(revision 434)
+++ tags/Ver2.2.0RC1/xpressme_integration_kit/wp-content/plugins/xpressme/include/xpress_common_functions.php	(revision 450)
@@ -365,3 +365,55 @@
 }
 
+function get_block_file_path($mydirname,$file_name)
+{
+	global $xoops_config, $xpress_config;
+	$mydirpath = $xoops_config->xoops_root_path . '/modules/' . $mydirname;
+	$select_theme = xpress_ThemeTemplate(get_xpress_theme_name($mydirname));
+	$xpress_default_theme = 'xpress_default';
+	$select_block = '/wp-content/themes/' . $select_theme . '/blocks/' . $file_name;
+	$default_block = '/wp-content/themes/xpress_default/blocks/' . $file_name;
+	$select_block_path = $mydirpath . $select_block;
+	$default_block_path =  $mydirpath . $default_block;
+
+	$block_file_data = array();
+	$block_file_data['file_path'] = $default_block_path;
+	$block_file_data['error'] = '';
+
+	if($select_theme != $xpress_default_theme){
+		if (file_exists($select_block_path)){
+			$select_block_version = get_block_version($select_block_path);
+			$default_block_version = get_block_version($default_block_path);
+			if (version_compare($select_block_version,$default_block_version, "<")){
+				$block_file_data['file_path'] = $default_block_path;
+				if ($xpress_config->is_block_error_display){
+					$error_str = '<div style="color:red">';
+					$error_str .= sprintf(__('Block file %1$s is an old version %2$s.<br />used block file %3$s of new version %4$s.','xpressme'),$select_block,$select_block_version,$default_block,$default_block_version);
+					$error_str .= '</div>';
+					$block_file_data['error'] = $error_str;
+				}
+			} else {
+				$block_file_data['file_path'] = $select_block_path;
+				$block_file_data['error'] = '';
+			}
+		}
+	}
+	return $block_file_data;
+}
+
+function get_block_version($file_path = ''){
+	$array_file = file($file_path);
+	$pattern = '^[\s|\/]*[B|b]lock\s+[V|v]ersion\s*[:|;]\s*([0-9|.]*)';
+	$version = '0.1';
+	if (empty($file_path)) return $version;
+	if (!file_exists($file_path)) return $version;
+	if (count($array_file) > 5) $file_count = 5; else $file_count = count($array_file);
+	for ($i = 0 ; $i < $file_count ; $i++){
+		if (preg_match('/' . $pattern . '/' ,$array_file[$i],$matchs)){
+			$version = $matchs[1];
+			break;
+		}
+	}
+	return $version;
+}
+
 ?>
Index: tags/Ver2.2.0RC1/xpressme_integration_kit/wp-content/plugins/xpressme/include/xpress_upgrade.php
===================================================================
--- tags/Ver2.2.0RC1/xpressme_integration_kit/wp-content/plugins/xpressme/include/xpress_upgrade.php	(revision 450)
+++ tags/Ver2.2.0RC1/xpressme_integration_kit/wp-content/plugins/xpressme/include/xpress_upgrade.php	(revision 450)
@@ -0,0 +1,220 @@
+<?php
+function upgrade_page()
+{
+	global $xoops_config,$xpress_config;
+	
+	$xpress_version = $xoops_config->module_version . $xoops_config->module_codename;
+	$lang = WPLANG;
+
+	$check_url = "http://ja.xpressme.info/version_check/index.php?version=$xpress_version&lang=$lang";
+
+	echo	'<div class="wrap">'."\n";
+	echo		'<div id="icon-options-general" class="icon32"><br /></div>'."\n";
+	echo		'<h2>' . __('XPressME Upgrade', 'xpressme') . "</h2><br>\n";
+	
+	if(get_xpress_latest_version()){
+		$latest = get_option('xpressme_latest_version');
+//print_r($latest);
+		if ($latest) {
+			$site_url=$latest['url'];
+			$package=$latest['package'];
+			$latest_version=$latest['latest_version'];
+			$check_time=$latest['check_time'];
+		}
+
+
+		if (version_compare($xpress_version, $latest_version, '>')){
+				echo '<h3 class="response">';
+				printf(__('You are using a XPressME Integration Kit development version (%1$s). Cool! Please <a href="%2$s">stay updated</a>.', 'xpressme') , $xpress_version , $latest['develop_url']);
+				echo '</h3>';
+
+		} else if (version_compare($xpress_version, $latest_version, '<')) {
+			echo	'<h3 class="response">'. __('There is a new version of XPressME Integration Kit available for upgrade', 'xpressme') . '</h3>';
+			echo '<p>';
+	//		printf(__('You can upgrade to version %s automatically or download the package and install it manually:'),$latest_version);
+			printf(__('You can upgrade to version %s download the package and install it manually:', 'xpressme'),$latest_version);
+			echo '</p>';
+			echo '<a class="button" href="' . $package . '">';
+			printf(__('Download %s', 'xpressme') , $latest_version);
+			echo '</a>';
+			
+			if ($latest['diff_response'] == 'diff_exists'){
+				echo '<p>';
+				printf(__('You can download the differential file from version %s to %s and upgrade it manually:', 'xpressme'),$xpress_version,$latest['diff_latest_version']);
+				echo '</p>';
+				echo '<a class="button" href="' . $latest['diff_package'] . '">';
+					printf(__('Download differential file for %s', 'xpressme') , $latest['diff_latest_version']);
+				echo '</a>';
+			}
+		} else {
+			echo	'<h3 class="response">'. __('You have the latest version of XPressME Integration Kit. You do not need to upgrade', 'xpressme') . '</h3>';
+		}
+		
+		if ($latest['develop_response'] == 'development_exists'
+			&& !empty($latest['develop_package'])
+			)
+		{
+			echo '<h3 class="response">';
+			printf(__('You can use the development version %s download the package and install it manually:', 'xpressme'),$latest['develop_latest_version']);
+			echo '</h3>';
+			echo '<a class="button" href="' . $latest['develop_package'] . '">';
+			printf(__('Download %s', 'xpressme') , $latest['develop_latest_version']);
+			echo '</a>';
+		}
+
+	} else {
+		echo '<h3 class="response">';
+		printf(__('There is no response from <a href="%s">version check API</a> now. sorry, please confirm it after.', 'xpressme'),$check_url);
+		echo	"</div>\n";
+	}
+}
+
+function xp_remote_get($url, $headers = ""){
+	global $xoops_config;
+	$xpress_version = $xoops_config->module_version . $xoops_config->module_codename;
+
+	require_once( $xoops_config->module_path . '/wp-includes/class-snoopy.php');
+
+	// Snoopy is an HTTP client in PHP
+	$client = new Snoopy();
+	$client->agent = 'XPressME/' . $xpress_version;
+	$client->read_timeout = 2;
+	if (is_array($headers) ) {
+		$client->rawheaders = $headers;
+	}
+
+	@$client->fetch($url);
+	$response['response']['code'] = $client->status;
+	$response['body'] = $client->results;
+	return $response;
+	return $client;
+
+}
+
+function get_xpress_latest_version(){
+	global $wp_version, $wpdb, $wp_local_package;
+	global $xoops_config;
+	
+	$xpress_version = $xoops_config->module_version . $xoops_config->module_codename;
+	$lang = WPLANG;
+
+	$check_url = "http://ja.xpressme.info/version_check/index.php?version=$xpress_version&lang=$lang";
+	$request_options = array(
+	'timeout' => 3,
+	'user-agent' => 'WordPress/' . $wp_version . '; ' . get_bloginfo( 'url' )
+	);
+
+	if (! function_exists('wp_remote_get')) {
+		$response = xp_remote_get($check_url);
+		
+		if (empty($response['body'])) return false;
+	} else {
+	
+		$response = wp_remote_get($check_url, $request_options);
+		
+		if ( is_wp_error( $response ) )
+			return false;
+	}
+	if ( 200 != $response['response']['code'] )
+		return false;
+	$body = trim( $response['body'] );
+	$body = str_replace(array("\r\n", "\r"), "\n", $body);
+	$returns = explode("\n", $body);
+
+	if ( isset( $returns[0] ) ) $response = $returns[0]; else $response = '';
+	if ( isset( $returns[1] ) ) $url = clean_url( $returns[1] ); else $url = '';
+	if ( isset( $returns[2] ) ) $package = clean_url( $returns[2] ); else $package = '';
+	if ( isset( $returns[3] ) ) $latest_version = $returns[3]; else  $latest_version = '';
+	if ( isset( $returns[4] ) ) $lang = $returns[4]; else $lang = '';
+	
+	// diff 
+	if ( isset( $returns[6] ) ) $diff_response = $returns[6]; else $diff_response = '';
+	if ( isset( $returns[7] ) ) $diff_url = clean_url( $returns[7] ); else $diff_url = '';
+	if ( isset( $returns[8] ) ) $diff_package = clean_url( $returns[8] ); else $diff_package = '';
+	if ( isset( $returns[9] ) ) $diff_latest_version = $returns[9]; else  $diff_latest_version = '';
+	if ( isset( $returns[10] ) ) $diff_lang = $returns[10]; else $diff_lang = '';
+
+	// developer 
+	if ( isset( $returns[12] ) ) $develop_response = $returns[12]; else $develop_response = '';
+	if ( isset( $returns[13] ) ) $develop_url = clean_url( $returns[13] ); else $develop_url = '';
+	if ( isset( $returns[14] ) ) $develop_package = clean_url( $returns[14] ); else $develop_package = '';
+	if ( isset( $returns[15] ) ) $develop_latest_version = $returns[15]; else  $develop_latest_version = '';
+	if ( isset( $returns[16] ) ) $develop_lang = $returns[16]; else $develop_lang = '';
+
+	$write_options = array (
+		'response' => $response ,
+		'url' => $url ,
+		'package' => $package ,
+		'latest_version' => $latest_version ,
+		'lang' => $lang ,
+		'diff_response' => $diff_response ,
+		'diff_url' => $diff_url ,
+		'diff_package' => $diff_package ,
+		'diff_latest_version' => $diff_latest_version ,
+		'diff_lang' => $diff_lang ,
+		'develop_response' => $develop_response ,
+		'develop_url' => $develop_url ,
+		'develop_package' => $develop_package ,
+		'develop_latest_version' => $develop_latest_version ,
+		'develop_lang' => $develop_lang ,
+		'check_time' => time()
+	);
+	
+	$latest_version = get_option('xpressme_latest_version');
+	if (!$latest_version) {
+		add_option('xpressme_latest_version', $write_options);
+	} else {
+		update_option('xpressme_latest_version', $write_options);
+	}
+	return true;
+}
+
+function xpress_update_check() {
+	if ( defined('WP_INSTALLING') )
+		return;
+	global $pagenow;
+
+	$php_query_string = $_SERVER['QUERY_STRING'];
+
+	if ( 'admin.php' == $pagenow && 'page=upgrade_page' == $php_query_string)
+		return;
+
+	global $wp_version, $wpdb, $wp_local_package;
+	global $xoops_config;
+
+	$php_query_string = $_SERVER['QUERY_STRING'];
+	$xpress_version = $xoops_config->module_version . $xoops_config->module_codename;
+
+	$latest = get_option('xpressme_latest_version');
+	if (!$latest ) {
+		get_xpress_latest_version();
+		$latest = get_option('xpressme_latest_version');
+	}
+
+	if ($latest) {
+		$next_check = $latest['check_time'] + (60*60*24);
+		$now_time = time();
+		if ($next_check < $now_time ){
+			get_xpress_latest_version();
+			$latest = get_option('xpressme_latest_version');
+		}
+	}
+
+	if ($latest) {
+		$url=$latest['url'];
+		$package=$latest['package'];
+		$latest_version=$latest['latest_version'];
+		$check_time=$latest['check_time'];
+		$upgrade_page = $xoops_config->module_url . "/wp-admin/admin.php?page=upgrade_page";
+
+		if (version_compare($xpress_version, $latest_version, '<')) {
+			if ( current_user_can('manage_options') ){
+				$msg = sprintf( __('XPressME Integration Kit Version %1$s is available! <a href="%2$s">Please update now</a>.', 'xpressme'), $latest_version, $upgrade_page );
+			} else {
+				$msg = sprintf( __('XPressME Integration Kit Version %1$s is available! Please notify the site administrator.', 'xpressme'), $latest_version );
+			}
+			echo "<div id='update-nag'>$msg </div>";
+		}
+	}
+}
+?>
